minor bug fix
[distro-setup] / check-subvol-stale
index afa711f2efa6347a08967cbf3c371bacea2615f1..07926ef49e3af16535a2d62c915f37cd88552426 100644 (file)
 # See the License for the specific language governing permissions and
 # limitations under the License.
 
-# usage: $0 SUBVOL_MOUNTPOINT...
-#
-# In git, this is not not executable because it's meant to be installed
-# using ./install-my-scripts
-#
-# If latest subvols $@ are not mounted, exit 1, print message, and touch
-# /nocow/btrfs-stale/$subvol
-#
-# Either SUBVOL_MOUNTPOINT is a snapshot of the latest, or
-# the latest snapshot is snapshot of SUBVOL_MOUNTPOINT.
 
-[[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
+[[ $EUID == 0 ]] || exec sudo -E "${BASH_SOURCE[0]}" "$@"
 
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 shopt -s nullglob
 
-if [[ ! $@ ]]; then
-    echo "$0: error: expected mountpoint argument"
-fi
+usage() {
+  cat <<EOF
+usage: $0 SUBVOL_MOUNTPOINT...
 
-stale-file() {
-    stale_dir=/nocow/btrfs-stale
-    stale_file=$stale_dir/$vol
-    if $stale; then
-        mkdir -p $stale_dir
-        printf "%s\n" $freshest_snap > $stale_file
-        ret=1
-    else
-        rm -f $stale_file
-    fi
+In git this is not not executable because it's meant to be installed
+using ./install-my-scripts
 
-}
+If latest subvols \$@ are not mounted, print a message, and print
+the unstale subvol name into /nocow/btrfs-stale/\$subvol
 
-ret=0
-for d; do
-    vol=${d##*/}
-    dev=$(sed -rn "s,^\s*([^#]\S*)\s+$d\s.*,\1,p" /etc/fstab|head -n1)
-    subvol_dir=$(sed -rn "s,^\s*[^#]\S*\s+$d\s.*\bsubvol=([a-zA-A/]+).*,\1,p" /etc/fstab|head -n1)
-    root_dir=$(sed -rn "s,^\s*$dev\s+(\S+).*\bsubvolid=0\b.*,\1,p" /etc/fstab|head -n1)
-    svp=$root_dir/$subvol_dir # subvolume path
+Fresh is opposite of stale. To be fresh, either SUBVOL_MOUNTPOINT is a
+snapshot of the latest, or the latest snapshot is snapshot of
+SUBVOL_MOUNTPOINT.
 
+-d         Enable debug output
+-h|--help  Print help and exit.
 
+Note: Uses GNU getopt options parsing style
+EOF
+  exit $1
+}
 
-    snaps=($root_dir/btrbk/$subvol_dir.20*) # Assumes we are in the 21st century.
-    if [[ ! $snaps ]]; then
-        # no snapshots yet
-        echo "$0: warning. no snapshots found. this is expected for a brand new volume"
-        continue
-    fi
+##### begin command line parsing ########
+
+debug=false # default
+temp=$(getopt -l help,d hd "$@") || usage 1
+eval set -- "$temp"
+while true; do
+  case $1 in
+    -d) debug=true; shift ;;
+    -h|--help) usage ;;
+    --) shift; break ;;
+    *) echo "$0: Internal error! unexpected args: $*" ; exit 1 ;;
+  esac
+done
 
-    # get info on last received sub
-    last_received_gen=0
-    for f in ${snaps[@]}; do
-        show="$(btrfs sub show $f)"
-        if echo "$show" | grep -E "Received UUID:\s+[[:alnum:]]" &>/dev/null; then
-            cgen=$(echo "$show" | sed -rn 's,^\s*Gen at creation:\s+([0-9]+).*,\1,p')
-            if [[ $cgen -gt $last_received_gen ]]; then
-                last_received_cgen=$cgen
-                last_received=$f
-            fi
-        fi
-    done
-
-    # Get last_snap by date.
-    # when a btrbk bugfix makes it into the distro,
-    # we might replace this with btrbk list latest /mnt/root/$vol | ...
-    last_snap=$(
-        for s in ${snaps[@]}; do
-            f=${s##*/}
-            printf "%s %s\n" $(date -d $(sed -r  's/(.{4})(..)(.{5})(..)(.*)/\1-\2-\3:\4:\5/' <<<${f#$vol.}) +%s) $f
-        done | sort -r | head -n 1 | awk '{print $2}'
-             )
-    if [[ ! $last_snap ]]; then
-        # should not happen.
-        echo "$0: error: could not find latest snapshot for $svp among ${snaps[*]}"
-        ret=1
-        continue
-    fi
+if [[ ! $1 ]]; then
+  echo "$0: error: expected mountpoint argument"
+fi
 
-    if [[ ! -e $svp ]]; then
-        echo "$0: warning: subvol we want to check does not exist: $svp"
-        stale-file=$last_snap
-        stale-file
-        continue
-    fi
+stale-file() {
+  stale_dir=/nocow/btrfs-stale
+  stale_file=$stale_dir/$vol
+  if $stale; then
+    mkdir -p $stale_dir
+    printf "%s\n" $freshest_snap > $stale_file
+  else
+    rm -f $stale_file
+  fi
 
+}
+d() {
+  if $debug; then
+    printf "%s\n" "$*"
+  fi
+}
 
-    # if there is a last_received, we can assume stale or fresh if we are newer/older
-    if [[ $last_received ]]; then
-        svp_cgen=$(btrfs sub show $svp | sed -rn 's,^\s*Gen at creation:\s+([0-9]+).*,\1,p')
-        if [[ $svp_cgen -ge $last_received_cgen ]]; then
-            stale=false
-        else
-            echo "$svp stale: it's gen at creation, $svp_cgen, is earlier than the last received snapshot, $last_received's gen at creation: $last_received_cgen"
-            freshest_snap=$last_received
-            stale=true
-        fi
-        stale-file
-        continue
+for d; do
+  vol=${d##*/}
+  # second field, non-comment line == $d
+  dev=$(sed -rn "s,^\s*([^#]\S*)\s+$d\s.*,\1,p" /etc/fstab /etc/mtab|head -n1)
+
+  d dev=$dev
+  subvol_dir=$(sed -rn "s,^\s*[^#]\S*\s+$d\s.*\bsubvol=([a-zA-A/]+).*,\1,p" /etc/fstab /etc/mtab|head -n1)
+  d subvol_dir=$subvol_dir
+  # note, we need $dev because $d might not be mounted, and we do this loop
+  # because the device in fstab for the rootfs can be different.
+  for devx in $(btrfs fil show $dev| sed -rn 's#.*path (/\S+)$#\1#p'); do
+    d devx=$devx
+    root_dir=$(sed -rn "s,^\s*$devx\s+(\S+).*\bsubvolid=[05]\b.*,\1,p" /etc/mtab /etc/fstab|head -n1)
+    if [[ $root_dir ]]; then
+      d root_dir=$root_dir
+      break
     fi
-
+  done
+  if [[ ! $root_dir ]]; then
+    echo "$0: error could not find root subvol mount for $dev" >&2
+    exit 1
+  fi
+  svp=$root_dir/$subvol_dir
+  d "svp=$svp # subvolume path"
+
+  snaps=($root_dir/btrbk/$subvol_dir.20*) # Assumes we are in the 21st century.
+  if [[ ! ${snaps[*]} ]]; then
+    # no snapshots yet
+    echo "$0: warning: no snapshots found at $root_dir/btrbk/$subvol_dir.20*. this is expected for a brand new volume"
+    continue
+  fi
+
+  # get info on last received sub
+  last_received=
+  last_received_cgen=0
+  for f in ${snaps[@]}; do
+    show="$(btrfs sub show $f)"
+    if echo "$show" | grep -E "Received UUID:\s+[[:alnum:]]" &>/dev/null; then
+      d found received uuid in $f
+      cgen=$(echo "$show" | sed -rn 's,^\s*Gen at creation:\s+([0-9]+).*,\1,p')
+      if [[ $cgen -gt $last_received_cgen ]]; then
+        last_received_cgen=$cgen
+        last_received=$f
+      fi
+    fi
+  done
+  d last_received_cgen=$last_received_cgen
+  d last_received=$last_received
+
+  # Get last_snap by date.
+  # when a btrbk bugfix makes it into the distro,
+  # we might replace this with btrbk list latest /mnt/root/$vol | ...
+  last_snap=$(
+    for s in ${snaps[@]}; do
+      f=${s##*/}
+      unix_time=$(date -d $(sed -r  's/(.{4})(..)(.{5})(..)(.*)/\1-\2-\3:\4:\5/' <<<${f#$vol.}) +%s)
+      printf "%s %s\n" $unix_time $s
+    done | sort -r | head -n 1 | awk '{print $2}'
+           )
+  if [[ ! $last_snap ]]; then
+    # should not happen.
+    echo "$0: error: could not find latest snapshot for $svp among ${snaps[*]}" >&2
+    exit 1
+  fi
+  d last_snap=$last_snap
+
+  if [[ ! -e $svp ]]; then
+    echo "$0: warning: subvol does not exist: $svp"
+    echo "$0 assuming this host was just for receiving and latest snap is freshest"
     freshest_snap=$last_snap
     stale=true
-    # fresh if $svp has $last_snap as a snapshot,
-    if btrfs sub show $svp 2>/dev/null | sed '0,/^\s*Snapshot(s):/d;s/^\s*//' | \
-            grep -xF btrbk/$last_snap &>/dev/null; then
-        stale=false
-    else # or else $svp is a snapshot of $last_snap. we use a uuid
-        # comparison, which if I remember from the docs, is a bit more
-        # robust, perhaps to renames.
-        last_snap_uuid=$(btrfs sub show $last_snap| awk '$1 == "UUID:" {print $2}')
-        if btrfs sub show $svp| grep "^\s*Parent UUID:\s*$last_snap_uuid$" &>/dev/null; then
-            stale=false
-        fi
-    fi
+    stale-file
+    continue
+  fi
+
 
+  # if there is a last_received, we can assume stale or fresh if we are newer/older
+  if [[ $last_received ]]; then
+    svp_cgen=$(btrfs sub show $svp | sed -rn 's,^\s*Gen at creation:\s+([0-9]+).*,\1,p')
+    d svp_cgen=$svp_cgen
+    if [[ $svp_cgen -ge $last_received_cgen ]]; then
+      stale=false
+    else
+      d "$svp stale: it's gen at creation, $svp_cgen, is earlier than the last received snapshot, $last_received's gen at creation: $last_received_cgen"
+      freshest_snap=$last_received
+      stale=true
+    fi
     stale-file
+    continue
+  fi
+
+  # fallback to using last_snap as the freshest
+  freshest_snap=$last_snap
+  stale=true
+  # fresh if $svp has $last_snap as a snapshot,
+  if btrfs sub show $svp 2>/dev/null | sed '0,/^\s*Snapshot(s):/d;s/^\s*//' | \
+      grep -xF ${last_snap#$root_dir/} ; then
+    stale=false
+  else # or else $svp is a snapshot of $last_snap. we use a uuid
+    # comparison, which if I remember from the docs, is a bit more
+    # robust, perhaps to renames.
+    last_snap_uuid=$(btrfs sub show $last_snap| awk '$1 == "UUID:" {print $2}')
+    if btrfs sub show $svp| grep "^\s*Parent UUID:\s*$last_snap_uuid$" &>/dev/null; then
+      stale=false
+    fi
+  fi
 
+  stale-file
 done
-exit $ret